DROP TABLE IF EXISTS `bindings`;
CREATE TABLE `bindings` (
  `owner` char(200) default NULL,
  `experiment` char(200) NOT NULL,
  `satEmail` char(200) NOT NULL,
  `satIdentifier` char(200) NOT NULL,
  `satIP` char(20) default NULL,
  `planetAddress` char(200) NOT NULL,
  `planetPort` int(11) default NULL,
  `validFrom` int(11) default NULL
);

DROP TABLE IF EXISTS `credit`;
CREATE TABLE `credit` (
  `email` char(200) NOT NULL,
  `identifier` char(200) NOT NULL,
  `whenOnline` int(11) default NULL,
  `onlineSec` int(11) default NULL,
  `ip` char(20) NOT NULL,
  `port` int(11) default NULL,
  `domain` char(100) default NULL,
  `version` int(11) default NULL,
  `bytesSent` int(11) default NULL,
  `bytesReceived` int(11) default NULL
);

DROP TABLE IF EXISTS `experiments`;
CREATE TABLE `experiments` (
  `owner` char(200) NOT NULL default '',
  `identifier` char(200) NOT NULL,
  `startTime` int(11) default NULL,
  `endTime` int(11) default NULL,
  `dynAllocPlanets` tinyint(1) default NULL,
  `dynAllocSats` tinyint(1) default NULL,
  `allowSatMigration` tinyint(1) default NULL,
  `satsLeftToAllocate` int(11) default NULL,
  `description` text,
  PRIMARY KEY  (`owner`,`identifier`)
);

DROP TABLE IF EXISTS `planets`;
CREATE TABLE `planets` (
  `owner` char(200) default NULL,
  `experiment` char(200) NOT NULL,
  `address` char(200) NOT NULL,
  `ip` char(20) default NULL,
  `port` int(11) default NULL
);

DROP TABLE IF EXISTS `satellites`;
CREATE TABLE `satellites` (
  `owner` char(200) default NULL,
  `experiment` char(200) default NULL,
  `email` char(200) NOT NULL,
  `identifier` char(200) NOT NULL,
  `planetPassword` char(20) NOT NULL,
  `virtualIP` char(20) default NULL,
  `rank` int(11) default NULL
);

DROP TABLE IF EXISTS `users`;
CREATE TABLE `users` (
  `username` char(200) NOT NULL,
  `password` char(200) default NULL,
  `sid` int(11) default NULL,
  `rights` int(11) default NULL,
  `firstname` char(200) default NULL,
  `lastname` char(200) default NULL,
  `email` char(200) default NULL,
  `institution` char(200) default NULL,
  `fullinst` char(200) default NULL,
  PRIMARY KEY  (`username`)
);
