#include <assert.h>
#include <ctype.h>
#include <sys/time.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <arpa/inet.h>

char *renderBytes(const unsigned char *data, int len, char *buf)
{
  buf[0] = 0;
  if (len > 0)
    sprintf(buf, "%02X", data[0]);
  for (int i=1; i<len; i++)
    sprintf(&buf[strlen(buf)], " %02X", data[i]);
  return buf;
}

void becomeDaemon()
{
  pid_t pid;

  if ((pid = fork()) != 0)
    exit(0);
  
  close(STDIN_FILENO);
  close(STDOUT_FILENO);
  close(STDERR_FILENO);
  
  /* Become process group leader */
    
  setsid();
  signal(SIGHUP, SIG_IGN);
  if ((pid = fork()) != 0)
    exit(0);
    
  /* Change to save execution environment */  
    
  umask(0);
}

int openServerSocket(int port, int type)
{
  int sock = socket(AF_INET, type, 0);
  if (sock < 0)
    return -1;
    
  sockaddr_in addr;
  memset(&addr, 0, sizeof(addr));
  addr.sin_family = AF_INET;
  addr.sin_port = htons(port);
  addr.sin_addr.s_addr = INADDR_ANY;
  if (bind(sock, (struct sockaddr*)&addr, sizeof(addr)) != 0)
    return -1;
    
  return sock;
}

char *ipdisp(int ip, char *buf)
{
  sprintf(buf, "%d.%d.%d.%d", ip&0xFF, (ip>>8)&0xFF, (ip>>16)&0xFF, (ip>>24)&0xFF);
  return buf;
}
